#include "channel.h"
#include "ui_channel.h"
#include <quwriter.h>

Channel::Channel(QWidget *parent, CumbiaPool *cu_p, const CuControlsFactoryPool &fp) :
    QWidget(parent), cu_pool(cu_p), m_ctrl_fpool(fp) {
    ui = new Ui::Channel;
    ui->setupUi(this, cu_p, fp);
    connect(ui->pbFix3k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
    connect(ui->pbFix5k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
    connect(ui->pbFix7k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
}

Channel::~Channel()
{
    delete ui;
}

void Channel::onPbFixClicked() {
    // FixedX(0) then VTargetX(NNNN) then FixedX(1) where X is the channel and NNNN the voltage
    // properties set in FourUHV::onPsListReady
    //
    // Request #17730: revert to single VTargetX(3000), VTargetX(5000) and so
    //
//    const QString& t0 = QString("$1/Fixed%1(0)").arg(sender()->property("channel").toInt());
    const QString& t1 = sender()->property("target").toString();
//    const QString& t2 = QString("$1/Fixed%1(1))").arg(sender()->property("channel").toInt());

    foreach(const QString& t, QStringList() << t1) {
        QuWriter *w = new QuWriter(this, cu_pool, m_ctrl_fpool);
        w->setAutoDestroy(true);
        w->setTarget(t);
//        printf("executing \"%s\"\n", qstoc(w->target()));
        w->execute();
    }
}
